# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section        devel

Summary:      Free Java implementation of OMG's CORBA standard
URL:          http://www.jacorb.org/
Source0:      http://www.jacorb.org/releases/2.2.4/JacORB-2.2.4-source.zip
Source1:      jacorb-idl-compiler-2.2.4.pom
Patch0:       jacorb-2.2.4-notification-build_xml.patch

Name:         jacorb
Version:      2.2.4
Release:      3jpp
Epoch:        0
License:      LGPL
Group:        Development/Java
BuildArch:    noarch
BuildRequires:    jpackage-utils >= 0:1.7.2
BuildRequires:    ant >= 0:1.6.5
BuildRequires:    antlr
BuildRequires:    concurrent
BuildRequires:    excalibur-avalon-framework-api
BuildRequires:    excalibur-avalon-framework-impl
BuildRequires:    excalibur-avalon-logkit
BuildRequires:    backport-util-concurrent
BuildRequires:    jakarta-commons-collections
BuildRequires:    jakarta-commons-logging
BuildRequires:    tanukiwrapper
BuildRequires:    picocontainer
BuildRequires:    xdoclet
BuildRequires:    xjavadoc
Requires:    jpackage-utils >= 0:1.7.2
Requires:    backport-util-concurrent
Requires:    concurrent
Requires:    excalibur-avalon-framework-api
Requires:    excalibur-avalon-framework-impl
Requires:    excalibur-avalon-logkit
Requires:    jakarta-commons-collections
Requires:    jakarta-commons-logging
Requires:    tanukiwrapper
Requires:    picocontainer
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
- high-performance, fully multithreaded ORB 
- IDL compiler, supports OMG IDL/Java language mapping 
  rev. 2.3, OBV 
- native IIOP, GIOP 1.2 and Bidirectional GIOP 
- POA (Portable Object Adapter) 
- AMI (Asynchronous Method Invocations) 
- ETF (Extensible Transport Framework) 
- POAMonitor, a GUI tools that lets you inspect your 
  object adapters (screenshot) 
- Dynamic Invocation Interface (DII) and Dynamic Skeleton 
  Interface (DSI) 
- Dynamic Management of Anys (DynAny) 
- Portable Interceptors (standard) 
- OMG Interoperable Naming Service 
- NameManager, a GUI browser for the name service 
  (requires Swing or JDK 1.2) (screenshot) 
- improved IIOP over SSL, includes KeyStoreManager 
- OMG Notification  and Event service 
- Transaction Service, Collection and Concurrency services 
- TradingService (supports trader links), an extension of 
  Mark Spruiell's free JTrader 
- CORBA 2.3 Code set support 
- Appligator, an IIOP proxy 
- Support for HTTP tunneling 
- Domain Manager, an object domain management service, 
  includes a domain browser GUI 
- Interface Repository 
- IRBrowser, a GUI front end for the Interface Repository
- Implementation Repository 
- Implementation Repository Manager, a GUI front end for 
  the Implementation Repository 
- IDL and Java source for all CORBA/COSS interfaces 
- examples and full source code included 
- 100% pure Java, JDK 1.3 and 1.4 compatible, also cooperates 
  with Sun's JDK 1.2 classes (releases prior to 1.4 are 
  compatible with JDK 1.1) 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation

%description javadoc
%{summary}

%package manual
Summary:        Documents for %{name}
Group:          Documentation

%description manual
%{summary}

%package demo
Summary:        Usage examples for %{name}
Group:          Development/Documentation

%description demo
%{summary}

%prep
%setup -q -n JacORB-2.2.4
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav

%build
pushd lib
ln -sf $(build-classpath antlr) .
ln -sf $(build-classpath excalibur/avalon-framework-api) .
ln -sf $(build-classpath excalibur/avalon-framework-impl) .
ln -sf $(build-classpath backport-util-concurrent) .
ln -sf $(build-classpath excalibur/avalon-logkit) .
ln -sf $(build-classpath picocontainer) .
ln -sf $(build-classpath tanukiwrapper) .
pushd build
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath xdoclet/xdoclet) .
ln -sf $(build-classpath xdoclet/xdoclet-ejb-module) .
ln -sf $(build-classpath xdoclet/xdoclet-jboss-module) .
ln -sf $(build-classpath xdoclet/xdoclet-jmx-module) .
ln -sf $(build-classpath xdoclet/xdoclet-mx4j-module) .
ln -sf $(build-classpath xdoclet/xdoclet-web-module) .
ln -sf $(build-classpath xjavadoc) .
popd
popd
# Tests were not included with the 2.2.4 source zip
#pushd test/regression/lib
#ln -sf $(build-classpath easymock) .
#ln -sf $(build-classpath emma) .
#ln -sf $(build-classpath emma_ant) .
#ln -sf $(build-classpath junit) .
#popd

ant all doc

%install
rm -rf $RPM_BUILD_ROOT

# remove DOS files
find . -name "*.exe" -exec rm {} \;
find . -name "*.bat" -exec rm {} \;

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 lib/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
install -p -m 0644 lib/idl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/idl-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -dm 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jacorb-idl.pom
%add_to_maven_depmap org.jacorb jacorb-idl-compiler %{version} JPP/jacorb idl

# bin, etc, idl
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
cp -pr bin/*   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/bin
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp -pr etc/*   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/idl
cp -pr idl/*   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/idl

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/doc
cp index.html   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/*   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/doc

# demo
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/demo

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root,-)
%{_javadir}/*
%{_docdir}/%{name}-%{version}/doc/LICENSE
%dir %{_datadir}/%{name}-%{version}/bin
%attr(0755,root,root) %{_datadir}/%{name}-%{version}/bin/*
%{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/idl
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/*

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}/demo

%changelog
* Mon Feb 19 2007 Deepak Bhole <dbhole@redhat.com> - 0:2.2.4-3jpp
- Adding pom file and appropriate depmap fragment for the idl compiler.
- Added missing BRs
- Remove post/postuns for javadoc and make dirs %%doc

* Sun Feb 18 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.4-2jpp
- Add missing requires

* Sun Feb 18 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.4-1jpp
- Upgrade

* Tue Aug 01 2006 Fernando Nasser <fnasser@redhat.com> 0:2.2.3-2jpp
- Add missing header
- Add missing dependency on picocontainer

* Fri Jul 21 2006 Ralph Apel <r.apel@r-apel.de> 0:2.2.3-1jpp
- Upgrade to 2.2.3
- First JPP-1.7 release

* Fri Jun 17 2005 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp
- Upgrade to 2.2.2

* Sat Dec 04 2004 Ralph Apel <r.apel at r-apel.de> 0:2.2-3jpp
- Include contents of bin, etc, idl
- TODO: which files from bin should go into _bindir

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.2-2jpp
- Rebuild with ant-1.6.2

* Fri Jul 30 2004 Ralph Apel <r.apel at r-apel.de> 0:2.2-1jpp
- First JPackage release
